/*@ requires n >= 1 && \valid(a+(0..n-1));
    ensures \forall integer i; 0 <= i < n ==> a[i] == \old(a[i])-1;
    ensures (\forall integer i; 0 <= i < n-1 ==> \old(a[i]) <= \old(a[i+1])) ==>
      (\forall integer i; 0 <= i < n-1 ==> a[i] <= a[i+1]);
    assigns a[0..n-1];
*/ 
void sub1 (int* a, int n) 
{ int i;
  
  /*@
      loop assigns i, a[0..n-1];
      loop invariant -1 <= i <= n-1;
      loop invariant
        \forall integer j; i < j <= n-1 ==> a[j] == \at(a[j], Pre)-1;
      loop invariant
        \forall integer j; 0 <= j <= i ==> a[j] == \at(a[j], Pre);
  */
  for (i=n-1; i>=0; i--)
    a[i]--;
} 
